#
# spec file for package elemental-post-build-generate-rpi-image
#
# Copyright (c) 2022 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#

Name:           elemental-post-build-generate-rpi-image
VCS: https://src.suse.de/SLFO-pool/elemental-post-build-generate-rpi-image#f1d3a0bcb1597ecf51fc65b579fe0f23d0877aff4d81d7a0d20e32d695937712
Summary:        Post build script to generate RPi image from Elemental ISO from a container
License:        GPL-2.0-or-later
Group:          Development/Tools/Building
Version:        0.4
Release:        160000.1.5
Requires:       buildah
# for truncate
Requires:       coreutils
# for mkfs.vfat
Requires:       dosfstools
# for mkfs.ext
Requires:       e2fsprogs
# for sfdisk
Requires:       util-linux
# for grub manipulation
Requires:       sed

%define post_build_dir /usr/lib/build/post_build.d

Source0:        generate-rpi-image.sh
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
An OBS post build hook that generates a RPi boot image from the Elemental ISO from a container.
The image is expected to be found at "/image/*.img".

%prep
cp %{S:0} .

%build

%install
install -D -m 755 generate-rpi-image.sh $RPM_BUILD_ROOT%{post_build_dir}/50-elemental-generate-rpi-image

%files
%defattr(-, root, root)
%dir /usr/lib/build
%dir %{post_build_dir}
%{post_build_dir}/50-elemental-generate-rpi-image


%changelog
* Mon Apr 22 2024 kkaempf@suse.com
- handle non-iso builds gracefully
* Thu Apr 11 2024 dcassany@suse.com
- Adapt to new rootfs.squashfs file path
* Tue Apr  2 2024 kkaempf@suse.com
- install to /usr/lib/build/post_build.d
* Thu Mar 28 2024 dcassany@suse.com
- Copying required files only <EFI>/boot path. This prevents
  dereferencing multiple links pointing to the same file, otherwise
  kernel and initrd are duplicated.
* Thu Mar 28 2024 kkaempf@suse.com
- fix flavor extraction (micro version was added to filename)
* Fri Mar 22 2024 kkaempf@suse.com
- follow symlinks when copying boot partition
* Thu Mar 14 2024 dcassany@suse.com
- Fix generator script: Do not patch partition label setup from
  grub.cfg.
* Thu Jan  4 2024 kkaempf@suse.com
- fix grub2 root partition (rancher/elemental#1151)
* Wed Jan  3 2024 kkaempf@suse.com
- switch ttyS0 baudrate to 115200 (standard for Raspberry Pi)
  (rancher/elemental#1139)
* Wed Dec 27 2023 kkaempf@suse.com
- iso name changed, adapt flavor extraction
- handle empty flavor
* Thu Sep 21 2023 kkaempf@suse.com
- fix copying of 'systemready' firmware
* Wed Sep 20 2023 kkaempf@suse.com
- move from parted to sfdisk (from util-linux)
- fix loop device setup
* Mon Apr 24 2023 dcassany@suse.com
- Adapt generation script to rancher/elemental-cli#404 so it makes
  use of the proper paths in after-install hooks.
* Tue Dec 27 2022 kkaempf@suse.com
- create checksum with .raw file.
* Wed Dec  7 2022 kkaempf@suse.com
- add last project name element to image name.
* Wed Dec  7 2022 kkaempf@suse.com
- create a timestamped image name.
* Thu Dec  1 2022 kkaempf@suse.com
- label the boot partition as RPI_BOOT.
* Tue Nov 29 2022 kkaempf@suse.com
- faking an .iso extension was a bad idea, breaks build service
  trying to sign the image.
* Mon Nov 28 2022 kkaempf@suse.com
- get image size from ~/.rpmmacros (Macros: in project config)
* Mon Nov 28 2022 kkaempf@suse.com
- make it downloadable (by faking an .iso extension)
* Sat Nov 26 2022 kkaempf@suse.com
- Initial version 0.1
